/**
 * Filename     : simulatorRk4.cc
 * Description  : Normal lattice simulation assuming spherical cells
 * Author(s)    : Henrik Jonsson (henrik@thep.lu.se)
 * Created      : February 2004
 * Revision     : $Id: simulatorRk4.cc 474 2010-08-30 15:23:20Z henrik $
 */
#include<vector>
#include<iostream>
#include"../../organism.h"
#include"../../solvers/rk4.h"

int main(int argc,char *argv[]) {
  
  //Input handling
  //////////////////////////////////////////////////////////////////////
  if( argc != 4 ) {
    std::cerr << "usage: " << argv[0] << " modelFile initFile "
	      << "simulatorParaFile\n";
    exit(-1);
  }
  std::string modelFile=argv[1];
  std::string initFile=argv[2];
  std::string simPara=argv[3];
  
  myTimes::getTime();
  //Define the organism (model) and simulator
  //////////////////////////////////////////////////////////////////////
  Organism O(modelFile,initFile);
  Rk4 S(&O,simPara);
  //O.printParameter();
  
  //Simulate with updates of the neighborhood
  //////////////////////////////////////////////////////////////////////
  std::cerr << "Start simulation.\n";
  S.simulate();
}
