/**
 * Filename     : simulatorSingleCell.cc
 * Description  : Organism simulation of one cell without updating neighborhood
 * Author(s)    : Henrik Jonsson (henrik@thep.lu.se)
 * Created      : May 2004
 * Revision     : $Id: simulatorSingleCell.cc 474 2010-08-30 15:23:20Z henrik $
 */
#include<vector>
#include<iostream>
#include"../../organism.h"
#include"../../solvers/rk5Adaptive.h"

int main(int argc,char *argv[]) {
  
  //Input handeling
  //////////////////////////////////////////////////////////////////////
  if( argc != 4 ) {
    std::cerr << "usage: " << argv[0] << " modelFile initFile "
	      << "simulatorParaFile\n";
    exit(-1);
  }
  std::string modelFile=argv[1];
  std::string initFile=argv[2];
  std::string simPara=argv[3];
  
  //Define organism (model) and simulator
  //////////////////////////////////////////////////////////////////////
  Organism O(modelFile,initFile);
  Rk5Adaptive S(&O,simPara);
  //O.printParameter();
  
  //Simulate without updating neighborhood
  //////////////////////////////////////////////////////////////////////
  S.simulateStaticNeighborhood();
}
