#ifndef SIMPLIFIEDAUXINTRANSPORTJTB_AUXINTRANSPORT_H
#define SIMPLIFIEDAUXINTRANSPORTJTB_AUXINTRANSPORT_H

#include "../baseReaction.h"
#include <cmath>

namespace SimplifiedAuxinTransportJTB
{
	class AuxinTransport : public BaseReaction
	{
	public:
		AuxinTransport(std::vector<double> &paraValue, 
			std::vector< std::vector<size_t> > &indValue );
		
		void derivs(Compartment &compartment,size_t species,
			std::vector< std::vector<double> > &y,
			std::vector< std::vector<double> > &dydt );
		
		double PIN1Feedback(double auxin);
		double AuxinActiveTransport(double auxin);
	};
}

#endif /* SIMPLIFIEDAUXINTRANSPORTJTB_AUXINTRANSPORT_H */
